package ftp;


import java.io.IOException;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.Channels;
import java.nio.channels.SocketChannel;
import java.nio.channels.WritableByteChannel;

public class FtpDataTransferProcess  {
	private  SocketChannel sockChan;
	
	
	/**
	 * Initialise les informations nécessaires aux actions du DTP du client FTP.
	 * @param socketAddr: adresse TCP/IP du DTP du serveur FTP.
	 * @throws IOException
	 */
	public FtpDataTransferProcess(InetSocketAddress socketAddr) throws IOException {
		sockChan = SocketChannel.open(socketAddr);
		System.out.println("Connexion ok");
		

	}
	
	
	/**
	 * Ferme le canal JAVA NIO relié à la connxion du DTP
	 * @throws IOException
	 */
	public void  close() throws IOException {
		if (sockChan != null) {
			sockChan.close();
			sockChan = null;
		}
	}
	
	/**
	 * Copie toutes les données reçues par la connexion DTP dans Stream fourni pour cela.
	 * @param fout: stream où devront être envoyées les données reçues du DTP du serveur
	 * @throws IOException
	 */
	public void receiveData(OutputStream fout) throws IOException {
		int res;
	
		if (sockChan == null) {
			return;
		}
		
		WritableByteChannel outChan =  Channels.newChannel(fout);
		
		ByteBuffer buff;
		buff =  ByteBuffer.allocate(2048);
		
		do {
			buff.clear();
			res = sockChan.read(buff);
		//	System.out.println(res + " octets lus");
			buff.flip();
			outChan.write(buff);
			
		} while (res > 0);
		close();
	//	System.out.println("Fin du receive data");
	}



}
